Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# ConnectionWriter Class Reference

This class handles threaded delivery of datagrams to various TCP or UDP sockets. More...

Inheritance diagram for ConnectionWriter:

List of all members.

## Public Member Functions
| ConnectionWriter (ConnectionManager manager, int num_threads, string thread_name)
| Creates a new ConnectionWriter with the indicated number of threads to handle output.
| ConnectionWriter (ConnectionManager manager, int num_threads)
| Creates a new ConnectionWriter with the indicated number of threads to handle output.
int | getCurrentQueueSize ()
| Returns the current number of things in the queue.
ConnectionManager | getManager ()
| Returns a pointer to the ConnectionManager object that serves this ConnectionWriter.
int | getMaxQueueSize ()
| Returns the maximum size the queue is allowed to grow to.
int | getNumThreads ()
| Returns the number of threads the ConnectionWriter has been created with.
bool | getRawMode ()
| Returns the current setting of the raw mode flag.
int | getTcpHeaderSize ()
| Returns the current setting of TCP header size.
bool | isImmediate ()
| Returns true if the writer is an immediate writer, i.e.
bool | isValidForUdp (Datagram const datagram)
| Returns true if the datagram is small enough to be sent over a UDP packet, false otherwise.
bool | send (Datagram const datagram, Connection connection, NetAddress const address)
| Enqueues a datagram for transmittal on the indicated socket.
bool | send (Datagram const datagram, Connection connection)
| Enqueues a datagram for transmittal on the indicated socket.
bool | send (Datagram const datagram, Connection connection, bool block)
| Enqueues a datagram for transmittal on the indicated socket.
bool | send (Datagram const datagram, Connection connection, NetAddress const address, bool block)
| Enqueues a datagram for transmittal on the indicated socket.
| setMaxQueueSize (int max_size)
| Limits the number of packets that may be pending on the outbound queue.
| setRawMode (bool mode)
| Sets the ConnectionWriter into raw mode (or turns off raw mode).
| setTcpHeaderSize (int tcp_header_size)
| Sets the header size of TCP packets.
| shutdown ()
| Stops all the threads and cleans them up.

## Detailed Description

This class handles threaded delivery of datagrams to various TCP or UDP sockets.

A ConnectionWriter may define an arbitrary number of threads (0 or more) to write its datagrams to sockets. The number of threads is specified at construction time and cannot be changed.

## Constructor & Destructor Documentation

ConnectionWriter | ( | ConnectionManager | manager,
|  | int | num_threads,
|  | string | thread_name
| ) |  |

Creates a new ConnectionWriter with the indicated number of threads to handle output.

If num_threads is 0, all datagrams will be sent immediately instead of queueing for later transmission by a thread.

ConnectionWriter | ( | ConnectionManager | manager,
|  | int | num_threads
| ) |  |

Creates a new ConnectionWriter with the indicated number of threads to handle output.

If num_threads is 0, all datagrams will be sent immediately instead of queueing for later transmission by a thread.

## Member Function Documentation

int getCurrentQueueSize | ( |  | ) |

Returns the current number of things in the queue.

ConnectionManager getManager | ( |  | ) |

Returns a pointer to the ConnectionManager object that serves this ConnectionWriter.

int getMaxQueueSize | ( |  | ) |

Returns the maximum size the queue is allowed to grow to.

See set_max_queue_size().

int getNumThreads | ( |  | ) |

Returns the number of threads the ConnectionWriter has been created with.

bool getRawMode | ( |  | ) |

Returns the current setting of the raw mode flag.

See set_raw_mode().

int getTcpHeaderSize | ( |  | ) |

Returns the current setting of TCP header size.

See set_tcp_header_size().

bool isImmediate | ( |  | ) |

Returns true if the writer is an immediate writer, i.e.

it has no threads.

bool isValidForUdp | ( | Datagram const | datagram | ) |

Returns true if the datagram is small enough to be sent over a UDP packet, false otherwise.

bool send | ( | Datagram const | datagram,
|  | Connection | connection,
|  | NetAddress const | address,
|  | bool | block
| ) |  |

Enqueues a datagram for transmittal on the indicated socket.

This form of the function allows the specification of a destination host address, and so is appropriate for UDP packets. Use the other send() method for sending TCP packets.

Returns true if successful, false if there was an error. In the normal, threaded case, this function only returns false if the send queue is filled; it's impossible to detect a transmission error at this point.

If block is true, this will not return false if the send queue is filled; instead, it will wait until there is space available.

bool send | ( | Datagram const | datagram,
|  | Connection | connection,
|  | NetAddress const | address
| ) |  |

Enqueues a datagram for transmittal on the indicated socket.

This form of the function allows the specification of a destination host address, and so is appropriate for UDP packets. Use the other send() method for sending TCP packets.

Returns true if successful, false if there was an error. In the normal, threaded case, this function only returns false if the send queue is filled; it's impossible to detect a transmission error at this point.

If block is true, this will not return false if the send queue is filled; instead, it will wait until there is space available.

bool send | ( | Datagram const | datagram,
|  | Connection | connection,
|  | bool | block
| ) |  |

Enqueues a datagram for transmittal on the indicated socket.

Since the host address is not specified with this form, this function should only be used for sending TCP packets. Use the other send() method for sending UDP packets.

Returns true if successful, false if there was an error. In the normal, threaded case, this function only returns false if the send queue is filled; it's impossible to detect a transmission error at this point.

If block is true, this will not return false if the send queue is filled; instead, it will wait until there is space available.

bool send | ( | Datagram const | datagram,
|  | Connection | connection
| ) |  |

Enqueues a datagram for transmittal on the indicated socket.

Since the host address is not specified with this form, this function should only be used for sending TCP packets. Use the other send() method for sending UDP packets.

Returns true if successful, false if there was an error. In the normal, threaded case, this function only returns false if the send queue is filled; it's impossible to detect a transmission error at this point.

If block is true, this will not return false if the send queue is filled; instead, it will wait until there is space available.

setMaxQueueSize | ( | int | max_size | ) |

Limits the number of packets that may be pending on the outbound queue.

This only has an effect when using threads; if num_threads is 0, then all packets are sent immediately.

setRawMode | ( | bool | mode | ) |

Sets the ConnectionWriter into raw mode (or turns off raw mode).

In raw mode, datagrams are not sent along with their headers; the bytes in the datagram are simply sent down the pipe.

Setting the ConnectionWriter to raw mode must be done with care. This can only be done when the matching ConnectionReader is also set to raw mode, or when the ConnectionWriter is communicating to a process that does not expect datagrams.

setTcpHeaderSize | ( | int | tcp_header_size | ) |

Sets the header size of TCP packets.

At the present, legal values for this are 0, 2, or 4; this specifies the number of bytes to use encode the datagram length at the start of each TCP datagram. Sender and receiver must independently agree on this.

shutdown | ( |  | ) |

Stops all the threads and cleans them up.

This is called automatically by the destructor, but it may be called explicitly before destruction.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties